package me.mrletsplay.scraperbot;

import java.util.ArrayList;
import java.util.List;
import java.util.regex.Pattern;

public class FilterList {

	private List<String> exact;
	private List<String> prefix;
	private List<String> regex;

	public FilterList() {
		this.exact = new ArrayList<>();
		this.prefix = new ArrayList<>();
		this.regex = new ArrayList<>();
	}

	public List<String> getExact() {
		return exact;
	}

	public List<String> getPrefix() {
		return prefix;
	}

	public List<String> getRegex() {
		return regex;
	}

	public boolean matches(String str) {
		return exact.contains(str)
				|| prefix.stream().anyMatch(p -> str.startsWith(p))
				|| regex.stream().anyMatch(r -> Pattern.matches(r, str));
	}

}
