package me.mrletsplay.scraperbot;

import java.util.ArrayList;
import java.util.List;

public class Utils {

	public static final int
		SPLIT_SPACES = 0,
		SPLIT_NEWLINES = 1,
		SPLIT_ANYHWERE = 2;

	public static List<String> splitToLength(String longString, int length, int splitPolicy) {
		switch(splitPolicy) {
			case SPLIT_ANYHWERE:
			{
				List<String> strings = new ArrayList<>();
				while(longString.length() > 0) {
					int subLen = Math.min(length, longString.length());
					String subStr = longString.substring(0, subLen);
					strings.add(subStr);
					longString = longString.substring(subLen);
				}

				return strings;
			}
			case SPLIT_SPACES:
			case SPLIT_NEWLINES:
			{
				List<String> strings = new ArrayList<>();
				while(longString.length() > 0) {
					int splitAt = 0;
					while(splitAt < longString.length()) {
						int nextCharacter = longString.indexOf(splitPolicy == SPLIT_SPACES ? ' ' : '\n', splitAt + 1); // Look for the next possible position to split
						if(nextCharacter == -1) nextCharacter = longString.length();
						if(nextCharacter > length) break;
						splitAt = nextCharacter;
					}

					if(splitAt == 0) splitAt = length; // There is no way for us to split at the requested character. Just cut it to the max length

					String subStr = longString.substring(0, splitAt);
					strings.add(subStr);
					longString = longString.substring(splitAt);
				}
				return strings;
			}
			default:
				throw new IllegalArgumentException("Invalid split policy");
		}
	}

}
